<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSendReeferCommandResultInfo ArrayType
 * @subpackage Arrays
 */
class ArrayOfSendReeferCommandResultInfo extends AbstractStructArrayBase
{
    /**
     * The SendReeferCommandResultInfo
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SendReeferCommandResultInfo[]
     */
    public $SendReeferCommandResultInfo;
    /**
     * Constructor method for ArrayOfSendReeferCommandResultInfo
     * @uses ArrayOfSendReeferCommandResultInfo::setSendReeferCommandResultInfo()
     * @param \StructType\SendReeferCommandResultInfo[] $sendReeferCommandResultInfo
     */
    public function __construct(array $sendReeferCommandResultInfo = array())
    {
        $this
            ->setSendReeferCommandResultInfo($sendReeferCommandResultInfo);
    }
    /**
     * Get SendReeferCommandResultInfo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SendReeferCommandResultInfo[]|null
     */
    public function getSendReeferCommandResultInfo()
    {
        return isset($this->SendReeferCommandResultInfo) ? $this->SendReeferCommandResultInfo : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSendReeferCommandResultInfo method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSendReeferCommandResultInfo method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSendReeferCommandResultInfoForArrayConstraintsFromSetSendReeferCommandResultInfo(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSendReeferCommandResultInfoSendReeferCommandResultInfoItem) {
            // validation for constraint: itemType
            if (!$arrayOfSendReeferCommandResultInfoSendReeferCommandResultInfoItem instanceof \StructType\SendReeferCommandResultInfo) {
                $invalidValues[] = is_object($arrayOfSendReeferCommandResultInfoSendReeferCommandResultInfoItem) ? get_class($arrayOfSendReeferCommandResultInfoSendReeferCommandResultInfoItem) : sprintf('%s(%s)', gettype($arrayOfSendReeferCommandResultInfoSendReeferCommandResultInfoItem), var_export($arrayOfSendReeferCommandResultInfoSendReeferCommandResultInfoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SendReeferCommandResultInfo property can only contain items of type \StructType\SendReeferCommandResultInfo, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SendReeferCommandResultInfo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\SendReeferCommandResultInfo[] $sendReeferCommandResultInfo
     * @return \ArrayType\ArrayOfSendReeferCommandResultInfo
     */
    public function setSendReeferCommandResultInfo(array $sendReeferCommandResultInfo = array())
    {
        // validation for constraint: array
        if ('' !== ($sendReeferCommandResultInfoArrayErrorMessage = self::validateSendReeferCommandResultInfoForArrayConstraintsFromSetSendReeferCommandResultInfo($sendReeferCommandResultInfo))) {
            throw new \InvalidArgumentException($sendReeferCommandResultInfoArrayErrorMessage, __LINE__);
        }
        if (is_null($sendReeferCommandResultInfo) || (is_array($sendReeferCommandResultInfo) && empty($sendReeferCommandResultInfo))) {
            unset($this->SendReeferCommandResultInfo);
        } else {
            $this->SendReeferCommandResultInfo = $sendReeferCommandResultInfo;
        }
        return $this;
    }
    /**
     * Add item to SendReeferCommandResultInfo value
     * @throws \InvalidArgumentException
     * @param \StructType\SendReeferCommandResultInfo $item
     * @return \ArrayType\ArrayOfSendReeferCommandResultInfo
     */
    public function addToSendReeferCommandResultInfo(\StructType\SendReeferCommandResultInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SendReeferCommandResultInfo) {
            throw new \InvalidArgumentException(sprintf('The SendReeferCommandResultInfo property can only contain items of type \StructType\SendReeferCommandResultInfo, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SendReeferCommandResultInfo[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\SendReeferCommandResultInfo|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\SendReeferCommandResultInfo|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\SendReeferCommandResultInfo|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\SendReeferCommandResultInfo|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\SendReeferCommandResultInfo|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SendReeferCommandResultInfo
     */
    public function getAttributeName()
    {
        return 'SendReeferCommandResultInfo';
    }
}
